OUTPUT_FORMAT("elf32-littlearm", "elf32-littlearm", "elf32-littlearm")
OUTPUT_ARCH(arm)
ENTRY(reset)
SECTIONS
{
 . = 0x00000000;
 . = ALIGN(4);
 .text :
 {
  start = .;
  *(.vectors)
  *(.__image_copy_start)
  arch/arm/cpu/armv7/start.o (.text*)
  *(.text*)
 }
 . = ALIGN(4);
 .rodata : { *(SORT_BY_ALIGNMENT(SORT_BY_NAME(.rodata*))) }
 . = ALIGN(4);
 __data_start = .;
 .data : {
  *(.data*)
 }
 __data_end = .;
 . = ALIGN(4);
 __preserve_data_start = .;
 . = __preserve_data_start + (__data_end - __data_start);
 __preserve_data_end = .;
 . = ALIGN(4);
 .u_boot_list . : {
  KEEP(*(SORT(.u_boot_list*)));
 }
 . = ALIGN(4);
 .image_copy_end :
 {
  *(.__image_copy_end)
 }
 _end = .;
 . = . + (10 * 1024);
 . = ALIGN(8);
 .bss_start : {
  KEEP(*(.__bss_start));
  __bss_base = .;
 }
 .bss __bss_base (OVERLAY) : {
  *(.bss*)
   . = ALIGN(4);
   __bss_limit = .;
 }
 .bss_end __bss_limit (OVERLAY) : {
  KEEP(*(.__bss_end));
 }
 /DISCARD/ : { *(.dynsym) }
 /DISCARD/ : { *(.dynstr*) }
 /DISCARD/ : { *(.dynamic*) }
 /DISCARD/ : { *(.plt*) }
 /DISCARD/ : { *(.interp*) }
 /DISCARD/ : { *(.gnu*) }
}
ASSERT((__bss_start - start) < (200 * 1024), "*** [size check error] U-Boot binary image bigger than 200KB");
ASSERT(((__bss_end - start) + (0) + (20 * 1024) + 256 + (8 * 1024) + (0xc0) + (1 << 10) + (1 << 10)) < (256 * 1024), "*** [size check error] U-Boot run time consume more than OCRAM size");
